#include"gmltimer.h"

#include<windows.h>
#include<mmsystem.h>

//////////////////////////////////////////////////////////////////////////////
///
//////////////////////////////////////////////////////////////////////////////

gml::Timer& gml::Timer::SystemTimer()
  {
  static gml::Timer s_system_timer;

  return s_system_timer;
  }

//////////////////////////////////////////////////////////////////////////////
///
//////////////////////////////////////////////////////////////////////////////

gml::Timer::Timer()
{
    LARGE_INTEGER freq;
    if(QueryPerformanceFrequency(&freq)) { 
        frequency = 4294967296.0*freq.HighPart+freq.LowPart;
        using_mm = 0;
    } else { // for old OS
        frequency = 1000;
        using_mm = 1;
    }
}

//////////////////////////////////////////////////////////////////////////////
///
//////////////////////////////////////////////////////////////////////////////

double gml::Timer::GetTime() const
{
    if(using_mm) 
        return timeGetTime();
    else {
        LARGE_INTEGER count;
        QueryPerformanceCounter(&count); 
        return 4294967296.0*count.HighPart+count.LowPart;      
    }
}


//////////////////////////////////////////////////////////////////////////////
///
//////////////////////////////////////////////////////////////////////////////

double gml::Timer::GetTimeMS() const
{
    return Ticks2Ms(GetTime());
}